
local gr = love.graphics
local button = { clicked = 0, active = true, font = gr.newFont( 20 ) }

function button.new(mode,txt,x,y,sx,sy)
	button[#button+1] = {qd=gr.newQuad(unpack(button.type[mode])),x=x,y=y,sx=sx,sy=sy,txt=txt}
	end

function button.mouseOver( c )
	local x,y = love.mouse.getPosition()
	if	x > c.x and
		x < c.x + c.w and
		y > c.y and
		y < c.y + c.h then
		return true
		end
	return false
	end

function button.draw( )
	if not button.active then return end
	local savefont	= gr.getFont()
	gr.setFont( button.font )
	for i = 1, #button do
		gr.setColor( 255, 255, 255 )
		local w		= gr.getFont():getWidth( button[i].txt )
		local h		= gr.getFont():getBaseline()
		local size	= button[i].sy
		local sizex	= button[i].sx
		if w > sizex * 123 - 20 then sizex = ( w + 20 ) / 123 end
		gr.draw( button.im, button[i].qd, button[i].x, button[i].y, 0, sizex, size )
		button[i].w	= sizex * 123
		button[i].h	= size * 58
		if button.mouseOver( button[i] ) then
			c = { 0, 0, 0 }
			else
			c = { 255, 255, 255 }	-- text white when mouse over
			end
		gr.setColor( c )
		local txtX = ( sizex * 123 ) / 2 - w / 2 + button[i].x
		local txtY = button[i].y + size * 50 / 2 - h / 2
		gr.print( button[i].txt, txtX, txtY )	-- add text to button
		end
	gr.setFont( savefont )
	end
-- load sprites
button.im 		= gr.newImage( 'Rect.png' )
button.type	= {}
local iw, ih	= button.im:getWidth(), button.im:getHeight()
for y = 1, 2 do
	for x = 1, 4 do		-- params specific to this spritesheet
		button.type[#button.type+1] = {146*(x-1)+42,144*(y-1)+58,123,58,iw,ih}
		end
	end

function button.key( key )
	if key == 'b'		then button.active = not button.active button.clicked = 0  end
	end

function button.event()
	if button.clicked>0 and button.active then return button.clicked else return false end
	end

function love.mousepressed( _, _, but )
	if but == "l" and button.active then
		for i = 1, #button  do
			if button.mouseOver( button[i] ) then button.clicked = i end
			end
		end
	end

return button
