-- start of a widget library

local button		= require 'button'
function love.load()
	love.window.setTitle( 'Simple Button Test' )
	love.window.setMode( 300, 300 )
	love.graphics.setBackgroundColor( 55, 55, 255 )
	-- button.new params: button type,button text, upper left corner x&y,button scale factors w&h
	-- button width automatically increased if text doesn't fit
	button.new(7,'GO',10,10,0.6,0.6)
	button.new(5,'STOP',10,50,0.6,0.6)
	button.new(1,'AntiClock',10,90,0.6,0.6)
	button.new(3,'Clockwise',10,130,0.6,0.6)
	button.new(2,'EXIT',200,250,0.5,0.4)
	fig = { x=0, y=0, rx=60, ry=80, cx=200, cy=100,
			angle=0, dir=5, run=1, sz = 5,
			recalc = function()
				fig.x = fig.rx * math.cos( fig.angle ) + fig.cx
				fig.y = fig.ry * math.sin( fig.angle ) + fig.cy
				end
			}
	end

function love.update( dt )
	fig.angle = fig.angle + fig.run * fig.dir * dt
	fig.recalc()
	if button.event() then		-- event handler ( button callback )
		local option = button.event()	-- event # based on order button created
		if option == 1 then fig.run = 1 end
		if option == 2 then fig.run = 0 end
		if option == 3 then fig.dir = -5 end
		if option == 4 then fig.dir = 5 end
		if option == 5 then love.event.quit() end
		end
	end

function love.draw()
	button.draw( )
	love.graphics.setColor( 255, 255, 0 )
	love.graphics.circle( 'line', fig.x, fig.y, fig.sz )
	love.graphics.print('<b> key to toggle buttons',10,270)
	end

function love.keypressed( key )
	if key == 'escape'	then love.event.quit() 	end
	button.key( key )
	end


